package com.zhongzheng.modules.course.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.course.bo.*;
import com.zhongzheng.modules.course.domain.CourseModuleChapter;
import com.zhongzheng.modules.course.vo.CourseChapterSectionVo;
import com.zhongzheng.modules.course.vo.CourseModuleChapterVo;
import com.zhongzheng.modules.course.vo.CourseSectionVo;
import com.zhongzheng.modules.course.vo.CourseUserModuleChapterVo;

import java.util.Collection;
import java.util.List;

/**
 * 模块与章关系Service接口
 *
 * @author hjl
 * @date 2021-10-11
 */
public interface ICourseModuleChapterService extends IService<CourseModuleChapter> {
	/**
	 * 查询单个
	 * @return
	 */
	CourseModuleChapterVo queryById(Long id);

	List<CourseModuleChapterVo> getListById(Long id);

	/**
	 * 查询列表
	 */
	List<CourseModuleChapterVo> queryList(CourseModuleChapterQueryBo bo);

	/**
	 * 根据新增业务对象插入模块与章关系
	 * @param bo 模块与章关系新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(CourseModuleChapterAddBo bo);

	/**
	 * 根据编辑业务对象修改模块与章关系
	 * @param bo 模块与章关系编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(CourseModuleChapterEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    List<CourseUserModuleChapterVo> chapterList(CourseMenuQueryBo bo);
}
